#include <iostream>
#include <vector>
using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    vector<int> dani(n);
    vector<int> koliko(n);
    for (int i=0;i<n;i++)
    {
        cin>>dani[i]>>koliko[i];
    }
    vector<int> pitanja(q);
    for (int i=0;i<q;i++)
    {
        cin>>pitanja[i];
    }

    vector<int> akumulirani(n);
    akumulirani[0]=koliko[0];
    for (int i=1;i<n;i++)
    {
        akumulirani[i]=akumulirani[i-1]+koliko[i];
    }

    for (int i=0;i<q;i++)
    {
        int k = pitanja[i];
        int pojedeno = k;
        int preostalo =0;

        for (int j=0;j<n;j++)
        {
            if (dani[j]<k)
            {
                preostalo =akumulirani[j];
            }
            else
            {
                break;
            }
        }
        if (pojedeno > preostalo)
        {
            pojedeno=preostalo;
        }
        cout<<pojedeno<<endl;
    }
}